local commonapi2_init = require "commonapi2.init"
local _syncdata = commonapi._syncdata

local firstHandleEventHandled = false
local firstHandleGuiEventHandled = false
local firstUpdateEventHandled = false


local savedata = {}
local secondaryui = require "commonapi2.ui2.secondaryui"

local commonapi_gamescript = {}
_G["commonapi_gamescript"] = commonapi_gamescript;

function commonapi_gamescript.getLineData()
	local lineData = {}
	local lineIds = game.interface.getLines()
	for i = 1, #lineIds do
		local line = game.interface.getEntity(lineIds[i])
		if (line.stops ~= nil) then
			line.stops_data = {}
			for s = 1, #line.stops do
				line.stops_data[#line.stops_data+1] = game.interface.getEntity(line.stops[s])
			end
		end
		lineData[#lineData+1] = line
	end

	return lineData
end

local lineextradetails = require("commonapi2.lineextradetails.lineextradetails")

local guisendscriptevent = false
function commonapi_gamescript.saveData()
	--print("commonapi_gamescript.saveData()")
	savedata.lineextradetails = lineextradetails.getStateData()
	guisendscriptevent = true
end

commonapi_gamescript.vehiclechanges = {}


local initialized = false

function data()
--	print("commonapi_gamescript:data", commonapi)
	--local initialized = false

	local data = {
		init = function ()
			return savedata
		end,
		save = function ()
			return savedata
		end,
		load = function (state)
			if initialized then return end
			if state == nil or next(state) == nil then return end
			savedata = state
			savedata.traceHandleEvent = false

			if (state.lineextradetails ~= nil) then
				lineextradetails.applySavegameData(state.lineextradetails)
			end

			initialized = true
		end,
		update = function ()
			if (#commonapi_gamescript.vehiclechanges > 0) then
				local ok, err = pcall(lineextradetails.onLineVehicleSetNextStationLater)
				if (ok == nil) then
					print(err)
				end
			end
			if firstUpdateEventHandled then return end
			if (commonapi._native ~= nil and commonapi._native.renameLuaState ~= nil) then
				commonapi._native.renameLuaState("Script Thread")
			end
			firstUpdateEventHandled = true
		end,
		handleEvent = function (src, id, name, param)
			if (id == "__commonapi2__") then
				if (name == "savedata") then
					--print("__commonapi2savedata__ called")
					savedata = param
					lineextradetails.notifyDataChange()
				end
				return
			end
			if (id ~= "saveevent") then -- and savedata.traceHandleEvent == true) then
				if (src == "CommonAPI2Native" and id == "TransportVehicleSystem" and type(param) == "table") then
					if (name == "setNextStation") then
						local retdata = lineextradetails.onLineVehicleSetNextStation(param)
						if (retdata ~= nil) then
							return retdata
						end
					end
				end
			end
			if firstHandleEventHandled then return end

			if (commonapi._native ~= nil and commonapi._native.renameLuaState ~= nil) then
				commonapi._native.renameLuaState("Script Thread")
			end
			firstHandleEventHandled = true
		end,

		guiUpdate = function()
			if (guisendscriptevent == true) then
				--print("guiUpdate() sending __commonapi2savedata__")
				guisendscriptevent = false
				game.interface.sendScriptEvent("__commonapi2__", "savedata", savedata)
			end
			if (secondaryui ~= nil) then
				if (secondaryui.isInit ~= true) then
					secondaryui.init()
				end
			end
		end,

		guiHandleEvent = function (id, name, param)
			if (secondaryui ~= nil) then
				if (secondaryui.traceGUICallback ~= nil) then
					pcall(secondaryui.traceGUICallback,"guiHandleEvent", id, name, param)
				end

				if (secondaryui.changeGUICallback ~= nil) then
					return secondaryui.changeGUICallback("guiHandleEvent", id, name, param)
				end
				if (id == "mainView" and name == "select") then
					secondaryui.lastEntitySelected = param
				end
			end
			if firstHandleGuiEventHandled then return end
			--print("commonapi_gamescript:guiHandleEvent", id, name)
			--commonapi._unique_threadid_check()
			if (commonapi._native ~= nil and commonapi._native.renameLuaState ~= nil) then
				commonapi._native.renameLuaState("GUI Thread")
			end
			firstHandleGuiEventHandled = true
		end,
	}
return data
end